% fil2.m
% fd, 21  novembre 2006. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Newton sur le probleme de point selle 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
hold off 
title ('Chainette numerique. Algorithme de Newton sur les equations \
de point selle.') ;
axis ( [ -.05 , 1.05 , -1.9  , 1.1 ] ) ;
longth = 1.6  , %  longth = 4.831525 
init = 0 ;  if (init==0) ; 
n=200 ; dx=1/n ;  x = zeros(1,n+1) ;  y=x ;  
for j = 1 : n+1 ;    %  initialisation droite 
xx = (j-1)*dx ; x(1,j:j) = xx ; y(1,j:j) = 1 - xx - 5*xx*(1-xx)  ; end ; 
plot ( x ,  y , '*b;;' , x,y,'r;;' ) ; pause ;  
lambda = 0.45   ;    %  ok pur longth = 1.67 
lambda = 1.26   ;    %  ok pur longth = 3.5 
lambda = 1.75   ;    %  ok pur longth = 4.5 
%  Tactique. tel que partir de longth = 3. 
%  Puis avancer la valeur de longth de .5 par continuation
 else ;  y=zz ; end ; 
% 
ro = 1  
for k = 1 : 10 ;        %  iterations de Newton
cout  = 0 ;  long = 0 ; for j = 1 : n ; 
yy = y(1,j:j) ; yyp1 = y(1,j+1:j+1) ; 
delta = yyp1-yy ; pp = .5*(yy+yyp1) + lambda ; 
rr = sqrt ( 1 + (delta/dx)**2 ) ; 
cout  = cout  + pp*rr ; long = long + rr ;  end ; 
cout = dx * cout  ,   long = dx * long ;  
%                                   gradients
gr  = zeros(1,n+1) ; grco  = zeros(1,n+1) ;  
for j = 1 : n ;  yy = y(1,j:j) ; yyp1 = y(1,j+1:j+1) ; 
delta = yyp1-yy ; pp = .5*(yy+yyp1) + lambda ;  
rr = sqrt ( 1 + (delta/dx)**2 ) ; 
gr (1,j:j)       = gr (1,j:j)       + .5*rr*dx - pp*delta / (rr*dx) ; 
gr (1,j+1:j+1)   = gr (1,j+1:j+1)   + .5*rr*dx + pp*delta / (rr*dx) ; 
grco (1,j:j)     = grco (1,j:j)     - delta / (rr*dx) ; 
grco (1,j+1:j+1) = grco (1,j+1:j+1) + delta / (rr*dx) ; 
end ; 
%                                   Hessienne
matelt = zeros(2,2,n) ;        %    matrices elementaires 
for j = 1 : n ;  yy = y(1,j:j) ; yyp1 = y(1,j+1:j+1) ; 
delta    = yyp1-yy ; 
pp       = .5*(yy+yyp1)  + lambda ; 
rr       = sqrt ( 1 + (delta/dx)**2 ) ; 
dshr     = delta / (dx*rr) ; 
pshr     =  pp / (rr*dx) ; 
pd2sh3r3 =  pp*delta**2 / ((dx**3)*(rr**3)) ; 
matelt(1:1,1:1,j:j) =  - dshr + pshr - pd2sh3r3 ; 
matelt(1:1,2:2,j:j) =         - pshr + pd2sh3r3 ; 
matelt(2:2,1:1,j:j) =    matelt(1:1,2:2,j:j) ; 
matelt(2:2,2:2,j:j) =    dshr + pshr - pd2sh3r3 ; 
end ; 
%                                   assemblage  
aa = zeros(1,n-1) ; bb = aa ; cc = aa ; 
aa(1,1:1) = matelt(2:2,2:2,1:1) ;   
for j = 2 : n-1 ; 
aa(1,j-1:j-1) = aa(1,j-1:j-1) +  matelt(1:1,1:1,j:j) ;  
bb(1,j:j)     = bb(1,j:j)     +  matelt(1:1,2:2,j:j) ; 
cc(1,j:j)     = cc(1,j:j)     +  matelt(2:2,1:1,j:j) ;   
aa(1,j:j)     = aa(1,j:j)     +  matelt(2:2,2:2,j:j) ;    
end ;       
aa(1,n-1:n-1) = aa(1,n-1:n-1) +  matelt(1:1,1:1,n:n) ; 
%                            resolution des systemes lineaires 
sm = aa ;  
for j = 1 : n-1 ;  sm(1,j:j) = gr (1,j+1:j+1) ; end ; 
%                                   resolution du systeme lineaire 
xx=tridia(n-1,aa,bb,cc,sm) ;       
for j = 1 : n-1 ;  sm(1,j:j) = grco (1,j+1:j+1) ; end ; 
xxco=tridia(n-1,aa,bb,cc,sm) ;      
%                                   produits scalaires
prod = 0 ;  ppss = 0 ;  
for j = 1 : n-1 ; 
prod = prod +  grco (1,j+1:j+1)*xx(1,j:j) ; 
ppss = ppss +  grco (1,j+1:j+1)*xxco(1,j:j) ; end ; 
dlam = ( long - longth - prod ) / ppss 
%                                         incremantation 
for j = 2 : n ; 
y(1,j:j) = y(1,j:j) - ro* (xx (1,j-1:j-1) + dlam*xxco(1,j-1:j-1)) ; end ;  
plot ( x ,  y , '*b;;' , x,y,'r;;' ) ; 
lambda = lambda + ro*dlam ; 
long , lambda , pause , end ; 
%                                   calcul de la valeur de theta  
for j = 2 : n ; 
yym1 = y(1,j-1:j-1) ; yy = y(1,j:j) ; yyp1 = y(1,j+1:j+1) ;  
if ((yy<=yym1)&(yy<=yyp1)) jth = j ; end ; end ; 
theta = (jth-1) * dx 
%
zz=y ;  


% xlabel ('200 points de grille, longueur imposee =  4.831525, \
% lambda calcule = 1.92017, minimum = 0.53 ') ; 
% gset terminal postscript ;  gset output "courbe053.ps" 
plot ( x ,  y , '*b;;' , x,y,'r;;' ) ; 